
;;; J.A.
;;; www.jorgeanjos.com
;;; www.cadtom.com

;;; VER 1.0 - 2002-09-02
;;; VER 2.0 - 2009-08-28

;;; Begin Sumper.lsp - Application to calculate the length of selected objects

(defun C:SUMPER	(/	  VADEC	   VALLPRC  GLG	     SSLEN    TPNAM
		 LGNAM	  LGSTOTAL LGTOTAL  TERM     TXSTOTAL TXTOTAL
		 TESTE
		)

  (setq VADEC (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "undo" "begin")
  (setq	VALLPRC	 (getvar "luprec")
	LGSTOTAL 0.0
	TERM	 0
  )
  (mlen)
  (while (/= TERM nil)
    (progn
      (mlen)
    )
  )
  (setq TXTOTAL (rtos LGSTOTAL 2 VALLPRC))
  (princ "\n Total = ")
  (princ TXTOTAL)
  (command "undo" "end")
  (setvar "cmdecho" VADEC)
)

;;;
;;;

(defun MLEN ()

  (princ "\n Select entities to calculate the length: \n")
  (terpri)
  (setq GLG (ssget))
  (if GLG
    (progn
      (setq SSLEN (sslength GLG))
      (while (> SSLEN 0)
	(setq TPNAM  (ssname GLG (setq SSLEN (1- SSLEN)))
	      ENTGT  (entget TPNAM)
	      ENTLAY (cdr (assoc 0 ENTGT))
	)
	(if (equal ENTLAY "LINE")
	  (setq TESTE 1)
	)
	(if (equal ENTLAY "POLYLINE")
	  (setq TESTE 1)
	)
	(if (equal ENTLAY "LWPOLYLINE")
	  (setq TESTE 1)
	)
	(if (equal ENTLAY "CIRCLE")
	  (setq TESTE 1)
	)
	(if (equal ENTLAY "ARC")
	  (setq TESTE 1)
	)
	(if (equal ENTLAY "SPLINE")
	  (setq TESTE 1)
	)
	(if (equal ENTLAY "ELLIPSE")
	  (setq TESTE 1)
	)
	(if (equal TESTE 1)
	  (progn
	    (command "lengthen" TPNAM "")
	    (setq LGTPNAM  (getvar "PERIMETER")
		  LGSTOTAL (+ LGTPNAM LGSTOTAL)
		  TESTE	   0
	    )
	  )
	)
      )
    )
    (princ "\n No entity was selected: \n")
  )
  (setq TXSTOTAL (rtos LGSTOTAL 2 VALLPRC))
  (initget "Add")
  (princ "\n Subtotal = ")
  (princ TXSTOTAL)
  (terpri)
  (setq	TERM
	 (getkword " [A] Add more entities or <Enter> to finish:  ")
  )
)
(princ "\n Type 'SUMPER' to start application ")

					; END Sumper.lsp
